//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Hsrm.EdgeGateway.GatewayService
{
    
    
    /// <summary>
    /// Class that implements the IGatewayService interface through SiLA2
    /// </summary>
    public partial class GatewayServiceClient : IGatewayService, System.ComponentModel.INotifyPropertyChanged, System.IDisposable
    {
        
        private System.Collections.Generic.ICollection<Server> _connectedServers;
        
        private System.Threading.Tasks.Task _connectedServersUpdateTask;
        
        private System.Lazy<bool> _hasNewFeature;
        
        private System.Threading.CancellationTokenSource _cancellationTokenSource = new System.Threading.CancellationTokenSource();
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.gateway.gatewayservice.v1.GatewayService";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public GatewayServiceClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
            InitLazyRequests();
        }
        
        /// <summary>
        /// Lists the servers connected to this gateway
        /// </summary>
        public virtual System.Collections.Generic.ICollection<Server> ConnectedServers
        {
            get
            {
                if ((_connectedServersUpdateTask == null))
                {
                    try
                    {
                        System.Threading.Monitor.Enter(_cancellationTokenSource);
                        if ((_connectedServersUpdateTask == null))
                        {
                            _connectedServersUpdateTask = _channel.SubscribeProperty<PropertyResponse<System.Collections.Generic.List<ServerDto>>>(_serviceName, "ConnectedServers", "org.silastandard/gateway/GatewayService/v1/Property/ConnectedServers", ReceiveNewConnectedServers, _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Property/ConnectedServers"), _cancellationTokenSource.Token);
                        }
                    } finally
                    {
                        System.Threading.Monitor.Exit(_cancellationTokenSource);
                    }
                }
                return _connectedServers;
            }
        }
        
        /// <summary>
        /// Signifies whether a new feature has been registered that requires a server restart to become available
        /// </summary>
        public virtual bool HasNewFeature
        {
            get
            {
                return _hasNewFeature.Value;
            }
        }
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        private void ReceiveNewConnectedServers(PropertyResponse<System.Collections.Generic.List<ServerDto>> connectedServers)
        {
            System.Collections.Generic.ICollection<Server> inner = connectedServers.Value.Extract(_executionManager.DownloadBinaryStore);
            if ((_connectedServers != inner))
            {
                _connectedServers = inner;
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if ((handler != null))
                {
                    handler.Invoke(this, new System.ComponentModel.PropertyChangedEventArgs("ConnectedServers"));
                }
            }
        }
        
        private bool RequestHasNewFeature()
        {
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Property/HasNewFeature");
            try
            {
                bool response = _channel.ReadProperty<PropertyResponse<Tecan.Sila2.BooleanDto>>(_serviceName, "HasNewFeature", "org.silastandard/gateway/GatewayService/v1/Property/HasNewFeature", callInfo).Value.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Disposes the current client and cancels all subscriptions
        /// </summary>
        public void Dispose()
        {
            _cancellationTokenSource.Cancel();
            _cancellationTokenSource.Dispose();
        }
        
        /// <summary>
        /// Initializes lazies for non-observable properties.
        /// </summary>
        private void InitLazyRequests()
        {
            _hasNewFeature = new System.Lazy<bool>(RequestHasNewFeature);
        }
        
        /// <summary>
        /// Performs a network discovery for the specified duration
        /// </summary>
        /// <param name="duration">The duration for which the gateway should look for servers</param>
        public virtual void ScanNetwork(long duration)
        {
            ScanNetworkRequestDto request = new ScanNetworkRequestDto(duration, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Command/ScanNetwork");
            try
            {
                _channel.ExecuteUnobservableCommand<ScanNetworkRequestDto>(_serviceName, "ScanNetwork", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Restarts the gateway
        /// </summary>
        public virtual void Restart()
        {
            RestartRequestDto request = new RestartRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Command/Restart");
            try
            {
                _channel.ExecuteUnobservableCommand<RestartRequestDto>(_serviceName, "Restart", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Set the name of a connected server
        /// </summary>
        public virtual void SetServerName(string serverUuid, string name)
        {
            SetServerNameRequestDto request = new SetServerNameRequestDto(serverUuid, name, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Command/SetServerName");
            try
            {
                _channel.ExecuteUnobservableCommand<SetServerNameRequestDto>(_serviceName, "SetServerName", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Get the identifiers of the required metadata
        /// </summary>
        /// <param name="identifier">The fully qualified identifier of the command or property</param>
        public virtual System.Collections.Generic.ICollection<string> GetRequiredMetadata(string serverUuid, string identifier)
        {
            GetRequiredMetadataRequestDto request = new GetRequiredMetadataRequestDto(serverUuid, identifier, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/gateway/GatewayService/v1/Command/GetRequiredMetadata");
            try
            {
                System.Collections.Generic.ICollection<string> response = _channel.ExecuteUnobservableCommand<GetRequiredMetadataRequestDto, GetRequiredMetadataResponseDto>(_serviceName, "GetRequiredMetadata", request, callInfo).ReturnValue.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Gateway Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class GatewayServiceClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/gateway/GatewayService/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IGatewayService);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new GatewayServiceClient(channel, executionManager);
        }
    }
}

